/*

Simplified BSD License
taken from
<http://www.opensource.org/licenses/bsd-license.php> 

Copyright (c) 2008, Saleem N. Bhatti <http://www.cs.st-andrews.ac.uk/~saleem/>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

  - Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  - Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

  - Neither the name of 'Saleem N. Bhatti' or 'Saleem Bhatti', nor the
    names of any other contributors may be used to endorse or promote
    products derived from this software without specific prior written
    permission.

DISCLAIMER
----------
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

27 November 2008

*/

/******************************************************************************
Some debugging stuff

saleem <http://www.cs.st-andrews.ac.uk/~saleem/>
November 2008
November 2001
March 1993
******************************************************************************/

#ifndef __d_print_h__
#define __d_print_h__

#include <stdio.h>

#if defined(__cplusplus)
extern "C" {
#endif

void d_advise(FILE *fp, const char *format, ...);
void d_error(FILE *fp, const char *format, ...);
void d_stderr(const char *format, ...); /* == d_advise(stderr, ...) */

#define D_HEXDUMP_addr ((unsigned char) 0x01)
#define D_HEXDUMP_data ((unsigned char) 0x02)
#define D_HEXDUMP_text ((unsigned char) 0x04)
#define D_HEXDUMP_all  ((unsigned char) 0xff)

void d_hexdump(FILE *fp,
               const unsigned char *ptr,
               const unsigned int length,
               const unsigned char what);

/* Handy macros */
#define D_ERROR(s_) \
    d_error(stderr, (char *) (s_) == (char *) 0 ? "" : (s_))

#define D_TRACER(s_) \
    d_stderr("file=%s line=%d %s", __FILE__, __LINE__, \
             (char *) (s_) == (char *) 0 ? "" : (s_))

#define D_HEXDUMP(p_, l_) \
    d_hexdump(stderr, (unsigned char *) p_, l_, D_HEXDUMP_all)

#if defined(__cplusplus)
}
#endif

#endif /* __d_print_h__ */

